datablock PlayerData(molotovSparkAnimPlayer : playerStandardArmor)
{
	shapeFile = "./model/molotov_whick.dts";
	boundingBox = "1 1 1";
	crouchboundingBox = "0.01 0.01 0.01";
	isEmptyPlayer = true;
	deathSound = "";
	painSound = "";
	useCustomPainEffects = true;
	deleteOnDrop = 1;
	mountSound = "";
	uiName = "";
};
datablock ShapeBaseImageData(molotovSparkAnim)
{
	emap = false;
	mountPoint = 1;
	eyeOffset = "0 0 0";
	doColorShift = true;
	shapeFile = "base/data/shapes/empty.dts";
	offset = "0 0 0";
	rotation = "1 0 0 90";
	
	stateName[0]					= "FireA";
	stateEmitter[0]					= molotovSparkEmitter;
	stateEmitterTime[0]				= 100;
	stateTransitionOnTimeout[0]		= "FireB";
	stateTimeoutValue[0]			= 100;
	
	stateName[1]					= "FireB";
	stateEmitter[1]					= molotovSparkEmitter;
	stateEmitterTime[1]				= 100;
	stateTransitionOnTimeout[1]		= "FireA";
	stateTimeoutValue[1]			= 100;
};

function player::armorScopeFirstPersonLoop(%pl)
{
	if(!isFunction(Player,setNetFlag))
		return;
	if(%pl.getMountedImage(0) == nameToId(molotovImage) && %pl.molotovIgnited)
	{
		if(isObject(%armorHead = %pl.getMountNodeObject($headSlot)))
		{
			%armorHead.setNetFlag(6,1);
			if(%pl.isFirstPerson())
				%armorHead.clearScopeToClient(%pl.client);
			else
				%armorHead.scopeToClient(%pl.client);
		}
		%pl.armorScopeFirstPersonLoopSched = %pl.schedule(32,armorScopeFirstPersonLoop);
	}
	else
	{
		if(isObject(%armorHead = %pl.getMountNodeObject($headSlot)))
		{
			%armorHead.setNetFlag(6,0);
			%armorHead.scopeToClient(%pl.client);
		}
	}
}