
datablock ItemData(ammoFlamerFuelItem : ammoBox9mmItemA)
{
	shapeFile = "./model/flamerFuel.dts";
	iconName = "./model/icon/icon_flamer";
	uiName = "Ammo Flamer Fuel";
	sAmmo = 75;
	sAmmoType = "flamerfuel";
	colorShiftColor = "1 1 1 1";
	doColorShift = false;
};
datablock AudioProfile(napalmFireLoop1Sound)
{
	filename	= "./sound/fire_loop1.wav";
	description = AudioDefaultLooping3d;
	preload = true;
};
datablock AudioProfile(napalmFireLoop2Sound)
{
	filename	= "./sound/fire_loop2.wav";
	description = AudioDefaultLooping3d;
	preload = true;
};
datablock AudioProfile(napalmFireEndSound)
{
	filename	= "./sound/fire_end.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(fleshFireLoopSound)
{
	filename	= "./sound/fire_fleshLoop.wav";
	description = AudioDefaultLooping3d;
	preload = true;
};
datablock AudioProfile(flamerFireLoopSound)
{
	filename	= "./sound/flamer_fireloop.wav";
	description = AudioDefaultLooping3d;
	preload = true;
};
datablock AudioProfile(flamerFireLoopStartSound)
{
	filename	= "./sound/flamer_fireStart.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(flamerFireLoopEndSound)
{
	filename	= "./sound/flamer_fireEnd.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(flamerTankExplodeSound)
{
	filename	= "./sound/flamer_tankExplode.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(flamerTankImpactSound)
{
	filename	= "./sound/flamer_tankImpact.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock ParticleData(flamerStreamParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 455;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 16.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.7 0.6 0.3 0.5";
	colors[1]     = "0.9 0.4 0.1 0.8";
	colors[2]     = "0.9 0.2 0.1 0.2";
	colors[3]     = "0.9 0.1 0.1 0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.8;
	sizes[2]      = 1.05;
	sizes[3]      = 1.45;
   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 0.6;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flamerStreamEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 35;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 5;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientOnVelocity = true;
   particles = flamerStreamParticle;
};
datablock ParticleData(flamerFleshBurningParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -3;
	inheritedVelFactor   = 0.7;
	constantAcceleration = 0.0;
	lifetimeMS           = 425;
	lifetimeVarianceMS   = 355;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 16.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.7 0.6 0.3 0.5";
	colors[1]     = "0.9 0.4 0.1 0.8";
	colors[2]     = "0.9 0.2 0.1 0.2";
	colors[3]     = "0.9 0.1 0.1 0";
	sizes[0]      = 0.75;
	sizes[1]      = 0.97;
	sizes[2]      = 1.45;
	sizes[3]      = 1.85;
   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 0.6;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flamerFleshBurningEmitter)
{
	ejectionPeriodMS = 4;
	periodVarianceMS = 0;
	ejectionVelocity = 1;
	velocityVariance = 0.4;
	ejectionOffset   = 0.4;
	thetaMin         = 0;
	thetaMax         = 180;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	orientOnVelocity = true;
	particles = flamerFleshBurningParticle;
};
datablock ParticleData(flamerBurningParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 455;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 16.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.7 0.6 0.3 0.5";
	colors[1]     = "0.9 0.4 0.1 0.8";
	colors[2]     = "0.9 0.2 0.1 0.2";
	colors[3]     = "0.9 0.1 0.1 0";
	sizes[0]      = 0.45;
	sizes[1]      = 0.67;
	sizes[2]      = 1.05;
	sizes[3]      = 1.85;
   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 0.6;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flamerBurningAEmitter)
{
   ejectionPeriodMS = 12;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1;
   ejectionOffset   = 0.1;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientOnVelocity = true;
   particles = flamerBurningParticle;
};
datablock ParticleEmitterData(flamerBurningBEmitter)
{
   ejectionPeriodMS = 12;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 1;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientOnVelocity = true;
   particles = flamerBurningParticle;
};
datablock ParticleData(flamerRubbishBurningParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -2;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 455;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 16.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.7 0.6 0.3 0.5";
	colors[1]     = "0.9 0.4 0.1 0.8";
	colors[2]     = "0.9 0.2 0.1 0.2";
	colors[3]     = "0.9 0.1 0.1 0";
	sizes[0]      = 0.67;
	sizes[1]      = 1.1;
	sizes[2]      = 1.2;
	sizes[3]      = 1.5;
	times[0] = 0.0;
	times[1] = 0.3;
	times[2] = 0.6;
	times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flamerRubbishBurningEmitter)
{
   ejectionPeriodMS = 12;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientOnVelocity = true;
   particles = flamerRubbishBurningParticle;
};
datablock ParticleData(flamerSparkParticle)
{
	dragCoefficient      = 4;
	gravityCoefficient   = -0.4;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 325;
	lifetimeVarianceMS   = 255;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 16.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.7 0.6 0.3 0.8";
	colors[1]     = "0.9 0.4 0.1 0.8";
	colors[2]     = "0.9 0.2 0.1 0.2";
	colors[3]     = "0.9 0.1 0.1 0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.17;
	sizes[2]      = 0.26;
	sizes[3]      = 0.14;
   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 0.6;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flamerSparkEmitter)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 0;
   ejectionVelocity = 9;
   velocityVariance = 0.2;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 20;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientOnVelocity = true;
   particles = flamerSparkParticle;
};
datablock DebrisData(flamerSparkDebris)
{
	shapeFile = "base/data/shapes/empty.dts";
	lifetime = 2;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 6;
	emitters[0] = flamerSparkEmitter;
};
datablock explosionData(flamerSparkExplosion)
{
	lifetimeMS = 50;
	debris 					= flamerSparkDebris;
	debrisNum 				= 4;
	debrisNumVariance 		= 3;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 140;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 6;
	debrisVelocityVariance 	= 2;
	explosionScale = "0.1 0.1 0.1";
	faceViewer = 1;
	offset = 0.3;
};
datablock projectileData(flamerSparkProjectile)
{
	explosion = flamerSparkExplosion;
};
datablock explosionData(flamerExplosion)
{
	soundProfile = "";
	lifetimeMS = 4000;
	emitter[0] = flamerBurningAEmitter;
	emitter[1] = flamerBurningBEmitter;
	subExplosion[0] = flamerSparkExplosion;
};
datablock projectileData(flamerFakeProjectile)
{
	explosion = flamerExplosion;
};
datablock projectileData(flamerProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	directDamage        	= 25;
	directDamageType    	= $DamageType::Flamer;
	radiusDamageType    	= $DamageType::Flamer;
	particleEmitter     	= "";
	uiName 					= "";
	explosion 				= "";
	explodeOnDeath = 0;
	muzzleVelocity 			= 45;
	gravityMod 				= 0;
	lifeTime = 1023;
	isBallistic 			= 1;
	noMetalImpact = 1;
	noBulletWhiz = 1;
};
datablock projectileData(flamerRubbishProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	particleEmitter     	= flamerRubbishBurningEmitter;
	isBallistic 			= 1;
	gravityMod 				= 1;
	lifeTime 				= 4023;
	explodeOnDeath 			= 1;
	explosion 				= "";
	muzzleVelocity = 5;
};
datablock ItemData(flamerItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "primary";

	shapeFile = "./model/flamerItem.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Flamer";
	iconName = "./model/icon/icon_flamer";
	fakeIcon = flamerIcon;
	doColorShift = true;
	colorShiftColor = "0.7 0.7 0.7 1";
	ammo = 1;
	canPutInSuitcase = 0;
	isLargeWeapon = 1;

	image = flamerImage;
	canDrop = true;
	
	sAmmoType = "flamerfuel";
	sAmmoMode = "reservePull";
	sAmmo = 75;
	spawnMaxAmmoAlways = 1;
};
datablock ShapeBaseImageData(flamerTankImage)
{
	emap = false;
	mountPoint = $backSlot;
	eyeOffset = "0 0 999";
	doColorShift = true;
	shapeFile = "./model/flamerTank.dts";
	offset = "0 0.04 -0.44";
	colorShiftColor = "0.7 0.4 0.4 1";
	
	stateName[0]				= "Idle";
	stateTransitionOnAmmo[0]	= "FireA";
	
	stateName[1]				= "FireA";
	stateSequence[1]			= "anim";
	stateEmitter[1]				= "flamerSparkEmitter";
	stateEmitterNode[1]			= "muzzlePoint";
	stateEmitterTime[1]			= 0.1;
	stateTimeoutValue[1]		= 0.04;
	stateTransitionOnTimeout[1]	= "FireB";
	stateTransitionOnNoAmmo[1]	= "Done";
	
	stateName[2]				= "FireB";
	stateSequence[2]			= "anim";
	stateEmitter[2]				= "flamerSparkEmitter";
	stateEmitterNode[2]			= "ejectPoint";
	stateEmitterTime[2]			= 0.1;
	stateTimeoutValue[2]		= 0.04;
	stateTransitionOnTimeout[2]	= "FireA";
	stateTransitionOnNoAmmo[2]	= "Done";
	
	stateName[3]				= "Done";
	stateSequence[3]			= "anim";
	
};
function flamerTankImage::onUnMount(%db,%pl,%slot)
{
	cancel(%pl.stopFlamerFireSched);
}
datablock ShapeBaseImageData(flamerFleshBurningImage)
{
	emap = false;
	mountPoint = $backSlot;
	eyeOffset = "0 0 -0.4";
	doColorShift = true;
	shapeFile = "base/data/shapes/empty.dts";
	offset = "0 0 -0.8";
	rotation = "1 0 0 90";
	
	stateName[0]					= "FireA";
	stateEmitter[0]					= flamerFleshBurningEmitter;
	stateEmitterTime[0]				= 100;
	stateTransitionOnTimeout[0]     = "FireB";
	stateTimeoutValue[0]            = 100;
	
	stateName[1]					= "FireB";
	stateEmitter[1]					= flamerFleshBurningEmitter;
	stateEmitterTime[1]				= 100;
	stateTransitionOnTimeout[1]     = "FireA";
	stateTimeoutValue[1]            = 100;
};
datablock ShapeBaseImageData(flamerImage)
{
	className = "WeaponImage";
	shapeFile = "./model/flamer.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0.02 0.04";
	item = flamerItem;
	ammo = " ";
	projectile = flamerProjectile;
	projectileSpread = 0.007;
	projectileSpeed = 45;
	projectileType = Projectile;
	eyeOffset = "0.7 1 -0.5";
	doColorShift = true;
	colorShiftColor = flamerItem.colorShiftColor;
	
	armReady = true;
	
	//eyeOffset = 0;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "Idle";
	
	stateName[1]					= "Idle";
	stateTransitionOnTriggerDown[1]	= "Trigger";
	
	stateName[2]					= "Trigger";
	stateScript[2]					= "onTrigger";
	stateTimeoutValue[2]			= 0.02;
	stateSequence[2]				= "trig";
	stateTransitionOnTimeout[2]		= "FireCheckA";
	
	stateName[3]					= "FireCheckA";
	stateScript[3]					= "onFireCheck";
	stateTimeoutValue[3]			= 0.01;
	stateTransitionOnTimeout[3]		= "FireCheckB";
	
	stateName[4]					= "FireCheckB";
	stateTransitionOnAmmo[4]		= "Fire";
	stateTransitionOnNoAmmo[4]		= "DryFire";
	
	stateName[5]					= "Fire";
	stateScript[5]					= "onFire";
	stateEmitter[5]					= flamerStreamEmitter;
	stateEmitterTime[5]				= 0.05;
	stateEmitterNode[5]				= "muzzlePoint";
	stateFire[5]					= true;
	stateEjectShell[5]				= true;
	stateSequence[5]				= "fire";
	stateTransitionOnTimeout[5]     = "Check";
	stateTimeoutValue[5]            = 0.05;
	
	stateName[6]					= "Check";
	stateTransitionOnTriggerDown[6] = "FireCheckC";
	stateTransitionOnTimeout[6]		= "Release";
	
	stateName[7]					= "Release";
	stateScript[7]					= "onRelease";
	stateSequence[7]				= "untrig";
	stateTimeoutValue[7]			= 0.1;
	stateTransitionOnTimeout[7]		= "Wait";
	
	stateName[8]					= "Wait";
	stateTimeoutValue[8]			= 0.45;
	stateTransitionOnTimeout[8]		= "Idle";
	
	stateName[9]					= "DryFire";
	stateScript[9]					= "onDryFire";
	stateSequence[9]				= "trig";
	stateTimeoutValue[9]			= 0.02;
	stateTransitionOnTriggerUp[9]	= "Release";
	
	stateName[10]					= "FireCheckC";
	stateScript[10]					= "onFireCheck";
	stateTimeoutValue[10]			= 0.01;
	stateEmitter[10]				= flamerStreamEmitter;
	stateEmitterTime[10]			= 0.05;
	stateEmitterNode[10]			= "muzzlePoint";
	stateTransitionOnTimeout[10]	= "FireCheckD";
	
	stateName[11]					= "FireCheckD";
	stateTransitionOnAmmo[11]		= "Fire";
	stateTransitionOnNoAmmo[11]		= "DryFire";
};
function flamerImage::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_rCheck(%db,%pl,%slot));
}
function flamerImage::onFire(%db,%pl,%slot)
{
	if(sWeps_loopingAudioStart(%db,%pl,%slot,flamerFireLoopSound))
	{
		%pl.playAudio(%slot+2,flamerFireLoopStartSound);
	}
	%proj = sWeps_fire(%db,%pl,%slot);
	%proj.deleteSched = %proj.schedule(340,delete);
	%val = sAmmo_rdec(%db,%pl,%slot);
	if(%val == 0)
		%pl.setImageAmmo(%slot,0);
	sAmmo_display(%pl);
}
function flamerImage::onRelease(%db,%pl,%slot)
{
	sWeps_loopingAudioEnd(%db,%pl,%slot,flamerFireLoopEndSound);
}
function flamerImage::onDryFire(%db,%pl,%slot)
{
	sWeps_loopingAudioEnd(%db,%pl,%slot,flamerFireLoopEndSound);
}
function flamerImage::onMount(%db,%pl,%slot)
{
	%pl.mountImage(flamerTankImage,1);
	parent::onMount(%db,%pl,%slot);
}
function flamerImage::onUnMount(%db,%pl,%slot)
{
	sWeps_loopingAudioEnd(%db,%pl,%slot,flamerFireLoopEndSound);
	%pl.unMountImage(1);
	parent::onUnMount(%db,%pl,%slot);
}

function flamerRubbishProjectile::onCollision(%db,%proj,%hit,%fade,%pos,%normal)
{
	flamerProjectileExplode(%proj);
}
function flamerProjectile::onCollision(%db,%proj,%hit,%fade,%pos,%normal)
{
	%vel = %proj.getVelocity();
	cancel(%proj.deleteSched);
	%proj.delete();
	if(%hit.getType() & $TypeMasks::PlayerObjectType)
	{
		if(%hit.getDatablock().noBurning)
		{
			return parent::onCollision(%db,%proj,%hit,%fade,%pos,%normal);
		}
		if(minigameCanDamage(%proj.client,%hit) == 1)
		{
			%hit.lastBurnDmgType = $DamageType::Flamer;
			%hit.lastFireAttacker = %proj.client;
			%hit.flamer_burnStart(4);
		}
	}
	else if(%hit.getType() & $TypeMasks::VehicleObjectType)
	{
		if(minigameCanDamage(%proj.client,%hit) == 1 && (isFunction(%hit.getClassName(),"fireHeatUp"))) //not really in the mood to put all the vehicle code in yet
		{
			%hit.fireHeatUp(%proj.client);
			return;
		}
	}
	else
	{
		flamerProjectileExplode(%proj);
		return;
	}
	parent::onCollision(%db,%proj,%hit,%fade,%pos,%normal);
}

function flamerProjectileExplode(%proj)
{
	%mask = $TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType;
	if(!isObject($flamerFireSet))
		$flamerFireSet = new simSet();
	%set = $flamerFireSet;
	%cnt = %set.getCount();
	%pos = %proj.getPosition();
	%attacker = %proj.client;
	%ignore = %proj.ignoreVehicles;
	%attackerPl = %proj.sourceObject;
	if(%cnt != 0)
	{
		%safety = 0;
		%ready = 0;
		while(!%ready && %safety < 12)
		{
			%pass = 1;
			for(%i=%cnt-1;%i>=0;%i--)
			{
				%obj = %set.getObject(%i);
				%fpos = %obj.position;
				%dist = vectorDist(%pos,%fpos);
				if(%dist < 1)
				{
					%pass = 0;
					%tmp = vectorAdd(%pos,(getRandom()-0.5)*2 SPC (getRandom()-0.5)*3 SPC 0);
					%ray = containerRayCast(%tmp,vectorAdd(%tmp,"0 0 -1.5"),%mask);
					if(getWord(%ray,0))
						%pos = %tmp;
					break;
				}
			}
			if(%pass)
				%ready = 1;
			%safety++;
		}
	}
	%damageType = %proj.damageType;
	if(%damageType $= "")
		%damageType = $DamageType::Flamer;
	%proj.delete();
	if(%pass)
	{
		%ray = containerRayCast(%pos,vectorAdd(%pos,"0 0 -1.5"),%mask);
		if(getWord(%ray,0))
			%pos = getWords(%ray,1,3);
	}
	%p = new projectile()
	{
		datablock = flamerFakeProjectile;
		initialPosition = %pos;
		initialVelocity = "0 0 -1";
	};
	%p.explode();
	%exp = new simSet()
	{
		tick = 0;
		sourceObject = %attackerPl;
		beGentleWith = %attackerPl;
		client = %attacker;
		position = %pos;
		ignoreVehicles = %ignore;
		damageType = %damageType;
	};
	$flamerFireSet.add(%exp);
	if(!isEventPending($flamerFireGlobalLoop))
		flamerExplosionLoop();
	flameSetAdd(getFlameSet(%exp),%exp);
}
function flamerExplosionLoop()
{
	cancel($flamerFireGlobalLoop);
	%set = $flamerFireSet;
	%cnt = %set.getCount();
	
	if(%cnt == 0)
		return;
	%sparks = 0;
	for(%i=%cnt-1;%i>=0;%i--)
	{
		%exp = %set.getObject(%i);
		%pos = %exp.position;
		%tick = %exp.tick;
		
		if(!getRandom(0,3) && %sparks > 0)
		{
			%p = new projectile()
			{
				datablock = flamerSparkProjectile;
				initialPosition = vectorAdd(%pos,"0 0 0.1");
				initialVelocity = "0 0 10";
			};
			%p.explode();
			%sparks--;
		}
		
		%dist = 2.5;
		%max = 10;
		%dmg = 3;
		%mask = $TypeMasks::PlayerObjectType;// | $TypeMasks::CorpseObjectType;
		initContainerRadiusSearch(%pos,mSqrt(%dist*%dist+%dist*%dist)+0.1,%mask);
		while(%hit = containerSearchNext())
		{
			if(%hit.getDatablock().noBurning)
				continue;
			%hPos = %hit.getPosition();
			%hDist = vectorDist(%pos,%hPos);
			if(%exp.beGentleWith == %hit)
			{
				if(%hDist > %dist/2)
					continue;
			}
			else if(%hDist > %dist)
				continue;
			
			%fact = ((%dist-%hDist)/%dist);
			if(%exp.beGentleWith == %hit)
				%fact *= 0.5;
			
			if(getSimTime()-%hit.lastFireDmg > 100)
			{
				cancel(%hit.burnSchedRem);
				%hit.lastFireDmg = getSimTime();
				%dmgd = %dmg*%fact;
				if(minigameCanDamage(%exp.client,%hit) == 1)
				{
					%hit.lastFireAttacker = %exp.client;
					%hit.lastBurnDmgType = %exp.damageType;
					%hit.flamer_burnStart(mCeil(%dmgd)*3);
				}
			}
		}
			
		%exp.tick++;
		if(%exp.tick > 60)
		{
			%clumpSet = %exp.set;
			%exp.delete();
			flameSetFlamePop(%clumpSet);
			%i--;
			continue;
		}
	}
	$flamerFireGlobalLoop = schedule(50,0,flamerExplosionLoop);
}