if(ForceRequiredAddon("Weapon_SWeps") == $Error::AddOn_NotFound)
	return;


AddDamageType("C4",'<bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_C4> %1','%2 <bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_C4> %1',1,1);
AddDamageType("FragGrenade",'<bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_frag> %1','%2 <bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_frag> %1',1,1);
AddDamageType("Molotov",'<bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_molotov> %1','%2 <bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_molotov> %1',1,1);
AddDamageType("GrenadeLauncher",'<bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_GL> %1','%2 <bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_GL> %1',1,1);
AddDamageType("Flamer",'<bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_fire> %1','%2 <bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_fire> %1',1,1);
AddDamageType("Crossbow",'<bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_crossbow> %1','%2 <bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_crossbow> %1',1,1);
AddDamageType("CrossbowHeadshot",'<bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_crossbow><bitmap:Add-Ons/Weapon_SWeps/model/icon/ci_headshot> %1','%2 <bitmap:Add-Ons/Weapon_SWeps_Ext/model/icon/ci_crossbow><bitmap:Add-Ons/Weapon_SWeps/model/icon/ci_headshot> %1',1,1);


swolammo_addAmmoType("flamerfuel","Flamer Fuel",75*2,75);
swolammo_addAmmoType("40mmGrenades","40mm Grenades",1*6,1);
swolammo_addAmmoType("bolts","Crossbow Bolts",24,6);

swolammo_addAmmoType("c4","C4",4,0);
swolammo_addVar("c4","ammoNameType","charge");
swolammo_addAmmoType("grenade","Frag Grenade",4,0);
swolammo_addVar("grenade","ammoNameType","grenade");
swolammo_addAmmoType("molotov","Molotov",4,0);
swolammo_addVar("molotov","ammoNameType","grenade");
swolammo_addAmmoType("syringe","Health Syringe",4,0);
swolammo_addVar("syringe","ammoNameType","syringe");


datablock ItemData(ammoBoltItem : ammoBox9mmItemA)
{
	shapeFile = "./model/ammo_bolt.dts";
	iconName = "./model/icon/icon_ammobolts";
	uiName = "Ammo Bolts";
	colorShiftColor = "0.7 0.7 0.8 1";
	sAmmo = 6;
	sAmmoType = "Bolts";
};


if($Add_On__Weapon_SWeps_FlareGun == 1)
{
	ForceRequiredAddon("Weapon_SWeps_FlareGun");
}
else
{
	datablock AudioProfile(flareGunDryFireSound : crossbowFireSound)
	{
		filename    = "./sound/flaregun_dryfire.wav";
		description = AudioClose3d;
	};
}

exec("./crossbow.cs");
exec("./gl.cs");
exec("./flamer.cs");
exec("./molotov.cs");
exec("./c4.cs");
exec("./frag.cs");
exec("./syringe.cs");
exec("./experimental.cs");

function createFireCircle(%pos,%rad,%amt,%cl,%obj,%damageType)
{
	for(%i=0;%i<%amt;%i++)
	{
		%rnd = getRandom();
		%dist = getRandom()*%rad;
		%x = mCos(%rnd*$PI*2)*%dist;
		%y = mSin(%rnd*$PI*2)*%dist;
		%p = new projectile()
		{
			datablock = flamerRubbishProjectile;
			initialPosition = %pos;
			initialVelocity = %x SPC %y SPC (getRandom()*4);
			client = %cl;
			sourceObject = %obj;
			damageType = %damageType;
		};
	}
}
function player::flamer_burnStart(%pl,%tick)
{
	//if(%pl.getDamagePercent() >= 1)
	//	return;
	if(!%pl.isBurning)
	{
		%pl.setTempColor("0.1 0.1 0.1 1");
		%pl.flamer_burn(%tick);
		%pl.flamerBurnTickAdd = 0;
	}
	else
	{
		%pl.flamerBurnTickAdd = %tick;
	}
}
function player::flamer_burn(%pl,%tick)
{
	cancel(%pl.flamerClearBurnSched);
	%pl.isBurning = 1;
	if(%pl.flamerBurnTickAdd > 0 && %pl.flamerBurnTickAdd > %tick)
	{
		%tick = mFloor(%pl.flamerBurnTickAdd);
		%pl.flamerBurnTickAdd = 0;
	}
	cancel(%pl.burnSched);
	if(!isObject(%pl.getMountedImage(3)))
	{
		%pl.mountImage(flamerFleshBurningImage,3);
	}
	if(!%pl.isPlayingBurningSound)
	{
		%pl.playAudio(3,fleshFireLoopSound);
		%pl.isPlayingBurningSound = 1;
	}
	
	%dmg = mClamp(%tick,3,6)*1.75;
	if(%pl.isCrouched())
		%dmg *= 0.47619;
	if(%pl.getDamagePercent() < 1)
	{
		%pl.damage(%pl.lastFireAttacker,%pl.getPosition(),%dmg,%pl.lastBurnDmgType);
		%pl.playThread(2,plant);
	}
	
	if(%tick <= 0)
	{
		%pl.unMountImage(3);
		%pl.isBurning = 0;
		%pl.playAudio(3,napalmFireEndSound);
		%pl.isPlayingBurningSound = 0;
		if(%pl.getDamagePercent() < 1)
		{
			%pl.flamerClearBurnSched = %pl.schedule(1500,flamer_clearBurn);
		}
		return;
	}
	%pl.burnSched = %pl.schedule(500,flamer_burn,%tick--);
}
function player::flamer_clearBurn(%pl)
{
	cancel(%pl.flamerClearBurnSched);
	%p = new projectile()
	{
		initialPosition = vectorAdd(%pl.getPosition(),"0 0 1");
		datablock = PlayerSootProjectile;
		scale = "0.7 0.7 0.7";
	};
	%p.explode();
	%pl.clearTempColor();
}


function cleanFlameSet()
{
	%tailClear = 1;
	for(%i=$flameSetCnt-1;%i>=0;%i--)
	{
		%set = $flameSet[%i];
		if(%set $= "")
		{
			if(%tailClear == 1)
			{
				$flameSetCnt--;
			}
			continue;
		}
		if(%set.getCount() == 0)
		{
			if(isObject(%set.soundObj))
				%set.soundObj.delete();
			%set.delete();
			$flameSet[%i] = "";
			if(%tailClear == 1)
			{
				$flameSetCnt--;
			}
		}
		else
		{
			%tailClear = 0;
		}
	}
}
function getFlameSet(%exp)
{
	%pos = %exp.position;
	for(%i=0;%i<$flameSetCnt;%i++)
	{
		if($flameSet[%i] $= "")
			continue;
		%med = $flameSet[%i].median;
		if(vectorDist(%pos,%med) < 6)
			return $flameSet[%i];
	}
	$flameSet[%i = $flameSetCnt] = new simSet();
	$flameSetCnt++;
	return $flameSet[%i];
}
function flameSetAdd(%set,%exp)
{
	%set.add(%exp);
	flameSetGenerateMedian(%set);
	flameSetPlayAudio(%set);
	%exp.set = %set;
}
function flameSetGenerateMedian(%set)
{
	%cnt = %set.getCount();
	%xAv = 0;
	%yAv = 0;
	%zAv = 0;
	for(%i=0;%i<%cnt;%i++)
	{
		%pos = %set.getObject(%i).position;
		%x = getWord(%pos,0);
		%y = getWord(%pos,1);
		%z = getWord(%pos,2);
		%xAv += %x;
		%yAv += %y;
		%zAv += %z;
	}
	%av = (%xAv/%cnt) SPC (%yAv/%cnt) SPC (%zAv/%cnt);
	%set.median = %av;
	
	//if(isObject(%set.debugObj))
	//	%set.debugObj.delete();
	//%set.debugObj = %q = SM_Debug.drawPoint(vectorAdd(%av,"0 0 2"),"1 0 0");
}
function flameSetPlayAudio(%set)
{
	if(isObject(%set.soundObj))
	{
		%set.soundObj.setTransform(%set.median);
	}
	else
	{
		%soundObj = %set.soundObj = new aiPlayer()
		{
			datablock = emptyPlayer;
			position = %set.median;
			audioBot = 1;
		};
		%soundObj.setDamageLevel(100);
		%soundObj.playAudio(0,napalmFireLoop @ getRandom(1,2) @ Sound);
	}
	//if(isObject(%set.debugObj))
	//	%set.debugObj.setTransform(vectorAdd(%set.median,"0 0 1"));
	//else
	//	%set.debugObj = SM_Debug.drawPoint(vectorAdd(%set.median,"0 0 1"));
}
function flameSetDestroy(%set)
{
	if(isObject(%set.soundObj))
		%set.soundObj.delete();
	if(isObject(%set.debugObj))
		%set.debugObj.delete();
	serverPlay3D(napalmFireEndSound,%set.median);
	cleanFlameSet();
}
function flameSetFlamePop(%set)
{
	if(%set.getCount() == 0)
	{
		flameSetDestroy(%set);
		return 0;
	}
	else
	{
		flameSetGenerateMedian(%set);
		flameSetPlayAudio(%set);
		return 1;
	}
}
function fragProjectile::onExplode(%db,%proj,%expos,%b)
{
	swol_explosionExtEffects(%proj,%expos);
	parent::onExplode(%db,%proj,%expos,%b);
}
function c4Projectile::onExplode(%db,%proj,%expos,%b)
{
	createFireCircle(%expos,5,3,%proj.client,%proj,$DamageType::C4);
	swol_explosionExtEffects(%proj,%expos);
	parent::onExplode(%db,%proj,%expos,%b);
}
function grenadeLauncherProjectile::onExplode(%db,%proj,%expos,%b)
{
	createFireCircle(%expos,7,8,%proj.client,%proj,$DamageType::GrenadeLauncher);
	swol_explosionExtEffects(%proj,%expos);
	parent::onExplode(%db,%proj,%expos,%b);
}
function swol_explosionExtEffects(%proj,%expos)
{
	%cnt = clientGroup.getCount();
	for(%i=0;%i<%cnt;%i++)
	{
		%cl = clientGroup.getObject(%i);
		%control = %cl.getControlObject();
		if(!isObject(%control))
			continue;
		if(!isFunction(%control.getClassName(),"getPosition"))
			continue;
		%pos = %control.getPosition();
		%dist = vectorDist(%expos,%pos);
		%toVec = vectorNormalize(vectorSub(%expos,%pos));
		if(%dist < 180)
		{
			%soundPos = vectorAdd(%pos,vectorScale(%toVec,%dist/5));
			%cl.play3D(grenadeLauncherExplosionB @ getRandom(1,2) @ Sound,%soundPos);
			%expScale = (1-(%dist/100))*0.3;
			if(%expScale > 0.06 && %control.getType() & $TypeMasks::PlayerObjectType)
			{
				%p = new projectile()
				{
					datablock = grenadeLauncherRumbleProjectile;
					initialPosition = %pos;
					scale = %expScale SPC %expScale SPC %expScale;
				};
				%p.explode();
			}
		}
		else if(%dist < 950)
		{
			%soundPos = vectorAdd(%pos,vectorScale(%toVec,%dist/12));
			%cl.play3D(grenadeLauncherExplosionC @ getRandom(1,2) @ Sound,%soundPos);
		}
	}
}
function player::remountC4Image(%pl)
{
	if(%pl.tool[%pl.currTool] != nameToId(c4Item))
		return;
	if(sAmmo_rCheck(c4Image,%pl,0) > 0)
	{
		%pl.mountImage(c4Image,0);
		%armRight = 1;
	}
	if(isObject(%pl.getMountedImage(1)))
	{
		%armLeft = 1;
	}
	if(%armRight+%armLeft == 2)
		%pl.playThread(1,armReadyBoth);
	else if(%armRight)
		%pl.playThread(1,armReadyRight);
	else if(%armLeft)
		%pl.playThread(1,armReadyLeft);
}
function player::doImageRemount(%pl,%im)
{
	if(%pl.tool[%pl.currTool] != nameToId(%im.item))
		return;
	if(sAmmo_rCheck(%im,%pl,0) > 0)
	{
		%pl.mountImage(%im,0);
	}

	%pl.playThread(1,armReadyRight);
}
function swol_hitFlamerTank(%pl,%hitPos)
{
	if(%pl.isCrouched())
	{
		%center = vectorAdd(%pl.getWorldBoxCenter(),"0 0 -1.49");
		%vecTo = vectorNormalize(vectorSub(%hitPos,%center));
		%up = %pl.getUpVector();
		%dot = vectorDot(%up,%vecTo);
		if(%dot > 0.1)
			return 1;
		return 0;
	}
	else
	{
		%center = %pl.getWorldBoxCenter();
		%z = getWord(%hitPos,2);
		%zWorld = getWord(%center,2);
		%diff = %zWorld-%z;
		%diff = 2.6-(%diff-2.65);
		if(%diff < 1.85 && %diff > 0.9)
		{
			%vecTo = vectorNormalize(vectorSub(getWords(%hitPos,0,1) SPC 0,getWords(%center,0,1) SPC 0));
			%forward = %pl.getForwardVector();
			%dot = vectorDot(%vecTo,%forward);
			if(%dot < -0.4)
				return 1;
		}
		return 0;
	}
}
function flamer_fireExplodeLoop(%pl,%tick,%attacker)
{
	//if(%pl.getState() $= "Dead")
	//	return;
	if(%tick > 9)
		return;
	createFireCircle(%pl.getHackPosition(),0,1,%attacker,%attacker,$DamageType::Flamer);
	%pl.flamerBurnSched = schedule(500,%pl,flamer_fireExplodeLoop,%pl,%tick++,%attacker);
}
package swol_sweps_extpack
{
	function projectileData::onCollision(%db,%proj,%hit,%vec,%hitPos,%a,%b)
	{
		if(minigameCanDamage(%proj,%hit) == 1 && %hit.getType() & $TypeMasks::PlayerObjectType && !%hit.getDatablock().useCustomPainEffects)
		{
			if(%hit.getMountedImage(1) == nameToId(flamerTankImage))
			{
				if(vectorLen(%proj.getVelocity()) >= 80 && !%hit.flamerHasExploded && swol_hitFlamerTank(%hit,%hitPos))
				{
					%hit.flamerTankDmg += %db.directDamage;
					serverPlay3D(flamerTankImpactSound,%hit.getPosition());
					if(%hit.flamerTankDmg > 50)
					{
						%hit.flamerHasExploded = 1;
						%hit.flamer_burnStart(5);
						serverPlay3D(flamerTankExplodeSound,%hit.getPosition());
						createFireCircle(%hit.getHackPosition(),0,5,%proj.client,%proj,$DamageType::Flamer);
						flamer_fireExplodeLoop(%hit,0,%proj.client);
						%hit.setImageAmmo(1,1);
						%hit.stopFlamerFireSched = %hit.schedule(3000,setImageAmmo,1,0);
					}
				}
			}
		}
		parent::onCollision(%db,%proj,%hit,%vec,%hitPos,%a,%b);
	}
	function player::emote(%pl,%im,%override)
	{
		if(%pl.isBurning)
		{
			if(isObject(%im))
			{
				if(%im.getClassName() !$= "ProjectileData")
				{
					return;
				}
			}
		}
		parent::emote(%pl,%im,%override);
	}
	function serverCmdUseTool(%cl,%slot)
	{
		if(!isObject(%pl = %cl.player))
			return parent::serverCmdUseTool(%cl,%slot);
		if(%pl.disableCmdSwap)
			return parent::serverCmdUseTool(%cl,%slot);
		if(%pl.tool[%slot] == nameToId(c4Item))
		{
			if(sAmmo_rCheck(c4Image,%pl,0) > 0)
			{
				if(getSimTime()-%pl.lastC4ThrowTime > 300)
				{
					%pl.mountImage(c4Image,0);
					%armRight = 1;
				}
			}
			if(isObject(%pl.droppedC4Set))
			{
				if(%pl.droppedC4Set.getCount() > 0)
				{
					%pl.mountImage(c4TriggerImage,1);
					%armLeft = 1;
				}
			}
			if(%armRight+%armLeft == 2)
				%pl.playThread(1,armReadyBoth);
			else if(%armRight)
				%pl.playThread(1,armReadyRight);
			else if(%armLeft)
				%pl.playThread(1,armReadyLeft);
				
			%pl.currTool = %slot;
			return;
		}
		else
		{
			if(%im = %pl.getMountedImage(1))
			{
				if(%im == nameToId(c4TriggerImage))
				{
					%pl.unMountImage(1);
					%pl.playThread(1,armReadyRight);
				}
			}
		}
		return parent::serverCmdUseTool(%cl,%slot);
	}
	function serverCmdUnUseTool(%cl)
	{	
		if(!isObject(%pl = %cl.player))
			return parent::serverCmdUnUseTool(%cl);
		if(%pl.disableCmdSwap)
			return parent::serverCmdUnUseTool(%cl);
		if(%im = %pl.getMountedImage(1))
		{
			if(%im == nameToId(c4TriggerImage))
			{
				%pl.unMountImage(1);
			}
		}
		return parent::serverCmdUnUseTool(%cl);
	}
	function armor::doDismount(%db,%pl)
	{
		if(getSimTime()-%pl.suppressDismount < 100)
		{
			return;
		}
		return parent::doDismount(%db,%pl);
	}
	function weaponImage::onMount(%db,%pl,%slot)
	{
		if(%slot == 0)
		{
			if(nameToId(%db.item) != nameToId(c4Item))
			{
				if(%im = %pl.getMountedImage(1))
				{
					if(%im == nameToId(c4TriggerImage))
					{
						%pl.unMountImage(1);
						%pl.playThread(1,armReadyRight);
					}
				}
			}
		}
		return parent::onMount(%db,%pl,%slot);
	}
	function gameConnection::onDeath(%cl,%killer,%b,%c,%d,%e)
	{
		if(isObject(%pl = %cl.player) && (isObject(%pl.droppedC4Set)))
			%pl.cleanupC4();
		return parent::onDeath(%cl,%killer,%b,%c,%d,%e);
	}
	function armor::onRemove(%db,%pl)
	{
		%pl.cleanupC4();
		parent::onRemove(%db,%pl);
	}
	function armor::onDisabled(%db,%pl)
	{
		if(isEventPending(%pl.molotovExplodeInHand))
		{
			sWeps_fire(molotovImage,%pl,0,0,1,1);
			%pl.unMountImage(0);
			cancel(%pl.molotovExplodeInHand);
		}
		if(isEventPending(%pl.fragExplodeInHand))
		{
			%p = sWeps_fire(fragImage,%pl,0,0,1,1);
			%time = (4000-(getSimTime()-%pl.fragPinPullTime));
			%p.explodeIn = %time+getSimTime();
			schedule(%time,%p,fragGrenade_explode,%p);
			%pl.unMountImage(0);
			cancel(%pl.fragExplodeInHand);
		}
		parent::onDisabled(%db,%pl);
	}
	function armor::onTrigger(%db,%pl,%trig,%bool)
	{
		if(%pl.tool[%pl.currTool] == nameToId(molotovItem))
		{
			if(%bool)
			{
				if(%trig == 0)
				{
					if((%im = %pl.getMountedImage(0)) && %im.item.getID() == nameToId(molotovItem))
					{
						if(!%pl.molotovIgnited)
						{
							if(getSimTime()-%pl.molotovMountTime > 500)
							{
								%pl.igniteMolotov();
							}
						}
						else if(getSimTime()-%pl.molotovIgniteTime > 500)
						{
							%p = sWeps_fire(%im,%pl,0,0,30,1);
							%p.schedule(11000-(getSimTime()-%pl.molotovIgniteTime),explode);
							cancel(%pl.molotovExplodeInHand);
							%pl.schedule(100,playThread,1,root);
							%pl.playThread(2,spearThrow);
							%pl.playThread(3,shiftTo);
							serverPlay3D(molotovThrowSound,%pl.getPosition());
							sAmmo_rDec(%im,%pl,0);
							%pl.unMountImage(0);
							%pl.schedule(300,doImageRemount,molotovImage);
							%pl.disableCmdSwap = 0;
							%pl.schedule(100,delayedCmdSwap);
						}
					}
				}
			}
		}
		if(%trig == 0 && %bool && !%pl.getMountedImage(0))
		{
			if(isObject(%pl.droppedC4Set))
			{
				if(%pl.droppedC4Set.getCount() > 0)
				{
					%eyeVec = %pl.getEyeVectorHack();
					%ray = containerRaycast(%pl.getEyePoint(),vectorAdd(%pl.getEyePoint(),vectorScale(%eyeVec,3)),$TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ItemObjectType);
				
					if(%hit = getWord(%ray,0))
					{
						if(%hit.getType() & $TypeMasks::ItemObjectType)
						{
							if(%hit.getDatablock() $= nameToId(c4DroppedItem))
							{
								if(%hit.canOnlyBePickedUpBy == %pl)
								{
									%hit.swol_pickupAmmo(%pl);
								}
							}
						}
					}
				}
			}
		}
		if(%pl.tool[%pl.currTool] == nameToId(c4Item))
		{
			if(%bool)
			{
				if(%trig == 0)
				{
					if(sAmmo_rCheck(c4Image,%pl,0) > 0)
					{
						if(getSimTime()-%pl.lastC4ThrowTime > 600)
						{
							%eyeVec = %pl.getEyeVectorHack();
							%angleFTol = vectorDot(%eyeVec,%pl.getForwardVector());
							%angleTTol = vectorDot(%eyeVec,"0 0 1");
							if(%angleFTol > 0.8)
							{
								%startPos = vectorAdd(%pl.getSlotTransform(0),vectorScale(%eyeVec,1));
								%vecMode = %eyeVec;
							}
							else
							{
								%startPos = vectorAdd(%pl.getHackPosition(),vectorScale(%pl.getForwardVector(),1));
								%vecMode = %pl.getForwardVector();
							}
							%ray = containerRaycast(%pl.getEyePoint(),vectorAdd(%pl.getEyePoint(),vectorScale(%eyeVec,3)),$TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType);
							if(getWord(%ray,0))
							{
								%startPos = vectorAdd(%pl.getPosition(),"0 0 0");
							}
							%i = new item()
							{
								datablock = c4DroppedItem;
								position = %startPos;
							};
							%i.canPickup = 0;
							%i.canOnlyBePickedUpBy = %pl;
							%i.setTransform(%i.getPosition() SPC rotFromTransform(%pl.getTransform()));
							%i.setVelocity(vectorAdd(vectorAdd(%pl.getVelocity(),vectorScale(%pl.getEyeVectorHack(),6)),"0 0 2"));
							%pl.unMountImage(0);
							%pl.playThread(2,shiftAway);
							serverPlay3D(dropGeneric @ getRandom(1,2) @ Sound,%pl.getPosition());
							sAmmo_rDec(c4Image,%pl,0);
							if(!isObject(%pl.droppedC4Set))
								%pl.droppedC4Set = new simSet();
							if(isObject(itemSet))
								itemSet.add(%i);
							%pl.droppedC4Set.add(%i);
							%pl.schedule(300,remountC4Image);
							%pl.lastC4ThrowTime = getSimTime();
							if(!isObject(%pl.getMountedImage(1)))
							{
								%pl.mountImage(c4TriggerImage,1);
								%pl.playThread(1,armReadyLeft);
							}
						}
					}
				}
				else if(%trig == 4)
				{
					if(%pl.getObjectMount())
					{
						%pl.suppressDismount = getSimTime();
					}
					if(isObject(%pl.droppedC4Set))
					{
						if((%cnt = %pl.droppedC4Set.getCount()) > 0)
						{
							if(getSimTime()-%pl.lastC4ThrowTime > 600)
							{
								if(isObject(%pl.getMountedImage(1)))
								{
									%pl.disableCmdSwap = 1;
									%pl.setImageTrigger(1,1);
									%pl.lastC4ThrowTime = getSimTime()+900;
									return;
								}
							}
						}
					}
				}
			}
			return;
		}
		parent::onTrigger(%db,%pl,%trig,%bool);
	}
};
activatePackage(swol_sweps_extpack);